<!--
  Copyright (c) 2009, Sun Microsystems, Inc. All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

  * Neither the name of Sun Microsystems, Inc. nor the names of its contributors
    may be used to endorse or promote products derived from this software without
    specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
  THE POSSIBILITY OF SUCH DAMAGE.
-->

<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%> 


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" href="css/demo.css" type="text/css" media="screen">

        <!-- Individual YUI CSS files -->
        <link rel="stylesheet" type="text/css" href="resources/yui_2.6.0/build/datatable/assets/skins/sam/datatable.css">
        <!-- Individual YUI JS files -->
        <script type="text/javascript" src="resources/yui_2.6.0/build/yahoo-dom-event/yahoo-dom-event.js"></script>
        <script type="text/javascript" src="resources/yui_2.6.0/build/element/element-beta.js"></script>
        <script type="text/javascript" src="resources/yui_2.6.0/build/datasource/datasource.js"></script>
        <script type="text/javascript" src="resources/yui_2.6.0/build/datatable/datatable.js"></script>

        <script>
            YAHOO.util.Event.addListener(window, "load", function() {

                // Create column definitions
                var myColumnDefs = [
                    {key:"id",label:"ID", sortable:true},
                    {key:"firstName",label:"First Name", sortable:true},
                    {key:"lastName",label:"Last Name", sortable:true},
                ];

                // Instantiate the DataSource
                this.myDataSource = new YAHOO.util.LocalDataSource(YAHOO.util.Dom.get("peopleTable"));
                this.myDataSource.responseType = YAHOO.util.DataSource.TYPE_HTMLTABLE;
                this.myDataSource.responseSchema = {
                    fields: [
                        {key:"id"},
                        {key:"firstName"},
                        {key:"lastName"},
                    ]
                };

                // DataTable constructor
                this.myDataTable = new YAHOO.widget.DataTable("myContainer", myColumnDefs, this.myDataSource,
                    {caption:"List of Persons currently in Database",
                        sortedBy:{key:"id",dir:"desc"}}
                    );
                    
            });
        </script>

        <title>Yahoo! UI Demo</title>
    </head>

    <body class="yui-skin-sam">
        <h1>Yahoo! UI Demo</h1>

        <div id="myContainer">
            <table id="peopleTable" border="1" cellpadding="10">
                <thead>
                    <tr>
                        <th bgcolor=>ID</th>
                        <th bgcolor=>FirstName</th>
                        <th bgcolor=>LastName</th>
                    </tr>
                </thead>
                <tbody>

                    <c:forEach var="person" begin="0" items="${requestScope.personList}">
                        <tr >
                            <td>${person.id}&nbsp;&nbsp;</td>
                            <td>${person.firstName}&nbsp;&nbsp;</td>
                            <td>${person.lastName}&nbsp;&nbsp;</td>
                        </tr>
                    </c:forEach>

                </tbody>
            </table>
        </div>

        <br>
        <a href="createPerson.jsp"><strong>Create a Person Record</strong></a>
    </body>
</html>